package org.stepik.android.presentation.certificate

import org.stepic.droid.model.CertificateViewItem
import org.stepik.android.model.Certificate
import ru.nobird.android.core.model.PagedList

interface CertificatesView {
    sealed class State {
        object Idle : State()
        object Loading : State()
        object EmptyCertificates : State()
        object NetworkError : State()

        class CertificatesCache(val certificates: PagedList<CertificateViewItem>) : State()
        class CertificatesRemote(val certificates: PagedList<CertificateViewItem>) : State()
        class CertificatesRemoteLoading(val certificates: PagedList<CertificateViewItem>) : State()
    }

    fun setState(state: State)
    fun showNetworkError()
    fun setBlockingLoading(isLoading: Boolean)

    fun showChangeNameSuccess()
    fun showChangeNameDialogError(certificate: Certificate, attemptedFullName: String)
}